&& avi_FileInfo
&& Gregory Adam 20070617
*==========================================================================
#include	"FoxPro.h"

#define TRUE	.T.
#define FALSE	.F.
*==========================================================================
*--------------------------------------------------------------------------
function avi_FileInfo_Object(obj)
	obj = null
	
	obj = createObject('avi_FileInfo')
	
	return inlist(vartype(m.obj), T_OBJECT)

endfunc
*--------------------------------------------------------------------------
#define	PAVIFILE		long
#define LPCTSTR			String @
#define	UINT			long
#define	CLSID			long 
#define AVIFILE_INFO	string

#define OF_SHARE_DENY_WRITE	0x00000020 

*==========================================================================
define class avi_FileInfo as Relation

	hidden	ChildAlias, ChildOrder, ClassLibrary, ;
			Comment, OneToMany, ;
			Parent, ParentAlias, RelationalExpr, Tag

	&& hidden InterfacePtr
	InterfacePtr	= 0
	
	FileInfo		= ''
	
	&& Approximate maximum data rate of the AVI file
	MaxBytesPerSec		= 0
	
	&& Flags
	Flags				= 0
	
	&& Capability flags
	Caps				= 0
	
	&& Number of streams in the file.
	&& For example, a file with audio and video has at least two streams.
	Streams				= 0
	
	&& Suggested buffer size, in bytes, for reading the file
	SuggestedBufferSize	= 0
	
	&& Width, in pixels, of the AVI file
	Width				= 0
	
	&& Height, in pixels, of the AVI file
	Height				= 0
	
	&& Time scale applicable for the entire file. Dividing dwRate by dwScale gives the number of samples per second. 
	&& Any stream can define its own time scale to supersede the file time scale.
	Scale				= 0
	
	&& Rate in an integer format. To obtain the rate in samples per second, divide this value by the value in dwScale
	Rate				= 0
	
	&& Length of the AVI file. The units are defined by dwRate and dwScale
	Length				= 0
	
	&& Number of streams that have been added to or deleted from the AVI file.
	EditCount			= 0
	
	&& Null-terminated string containing descriptive information for the file type
	FileType			= ''
	
	&& Seconds [added] 
	Seconds				= 0


*--------------------------------------------------------------------------
hidden function init()

	local Success
	Success = TRUE
	
	do case
	case !m.Success
	
	case !DoDefault()
		assert FALSE
		Success = FALSE
	
	case !m.this.Dll_Declare()
		assert FALSE
		Success = FALSE
		
	endcase
	
	return m.Success
	
endfunc
*--------------------------------------------------------------------------
hidden function Destroy()

	=m.this.InterfacePtr_Release()
	
	=AVIFileExit()
	
	return DoDefault()
	
endfunc
*--------------------------------------------------------------------------
hidden function Dll_Declare()

	local Success
	Success = TRUE
	
	declare AVIFileInit in avifil32.dll
	
	declare AVIFileExit in avifil32.dll
	
	declare long AVIFileOpen in avifil32.dll ;
		PAVIFILE @, ;
		LPCTSTR, ;
		UINT, ;
		CLSID
	
	declare long AVIFileRelease  in avifil32.dll ;
		PAVIFILE
	
	declare long AVIFileInfo in avifil32.dll ;
		PAVIFILE, ;
		AVIFILE_INFO @, ;
		long

	=AVIFileInit()
	
	return m.Success
	
endfunc
*--------------------------------------------------------------------------
hidden function InterfacePtr_Release()

	if( !empty(m.this.InterfacePtr) )
		=AVIFileRelease(m.this.InterfacePtr)
		this.InterfacePtr = 0
	endif
		
endfunc
*--------------------------------------------------------------------------
hidden function File_Open(FileName)

	local Success
	Success = TRUE
	
	local InterfacePtr
	InterfacePtr = 0
	
	do case
	case !m.Success
	
	case !empty(AVIFileOpen(@m.InterfacePtr, m.FileName, OF_SHARE_DENY_WRITE, 0))
		assert FALSE
		Success = FALSE
	
	otherwise
		this.InterfacePtr = m.InterfacePtr
	
	endcase
	
	return m.Success

endfunc
*--------------------------------------------------------------------------
function Info_get(FileName)

	local Success
	Success = TRUE
	
	do case
	case !m.Success
	
	case !m.this.File_Open(m.FileName)
		assert FALSE
		Success = FALSE
	
	case !m.this.File_Info()
		assert FALSE
		Success = FALSE
		
	endcase
	
	=m.this.InterfacePtr_Release()
	
	return m.Success

endfunc
*--------------------------------------------------------------------------
#if FALSE
typedef struct { 
    DWORD dwMaxBytesPerSec; 
    DWORD dwFlags; 
    DWORD dwCaps; 
    DWORD dwStreams; 
    DWORD dwSuggestedBufferSize; 
    DWORD dwWidth; 
    DWORD dwHeight; 
    DWORD dwScale; 
    DWORD dwRate; 
    DWORD dwLength; 
    DWORD dwEditCount; 
    char  szFileType[64]; 
} AVIFILEINFO; 

#endif

hidden function File_Info()

	local Success
	Success = TRUE
	
	local FileInfo
	FileInfo = space(11*4 + 64)
	
	with m.this
		do case
		case !m.Success
		
		case !empty(AVIFileInfo(m.this.InterfacePtr, @m.FileInfo, len(m.FileInfo)))
			assert FALSE
			Success = FALSE
		
		otherwise
			.FileInfo	= m.FileInfo
			
			.MaxBytesPerSec			= .ctobin(0)
			.Flags					= .ctobin(1)
			.Caps					= .ctobin(2)
			.Streams				= .ctobin(3)
			.SuggestedBufferSize	= .ctobin(4)
			.Width					= .ctobin(5)
			.Height					= .ctobin(6)
			.Scale					= .ctobin(7)
			.Rate					= .ctobin(8)
			.Length					= .ctobin(9)
			.EditCount				= .ctobin(10)
			.Seconds				= (.Length * .Scale) / .Rate
			
			.FileType				= substr(m.FileInfo, 45, 64) + chr(0)
			.FileType				= left(.FileType, at(chr(0), .FileInfo)-1)
			
		
		endcase
	
	endwith
	
	return m.Success

endfunc
*--------------------------------------------------------------------------
hidden function ctobin(Offset)
	
	local s
	s = substr(m.this.FileInfo, Offset * 4 +1, 4)


	do case
	case len(m.s) = 4
		return asc(m.s)  + bitlshift(asc(substr(m.s,2,1)),8) + bitlshift(asc(substr(m.s,3,1)),16) + bitlshift(asc(substr(m.s,4,1)),24)
	
	case len(m.s) = 2
		return asc(m.s)  + bitlshift(asc(substr(m.s,2,1)),8)
		
	otherwise
		assert FALSE
		return FALSE
	
	endcase
endfunc
*----------------------------------------------------------------------------
*--------------------------------------------------------------------------
enddefine
*==========================================================================
*==========================================================================
*==========================================================================